<?php

set_time_limit(0);
// Binary functions
function getint1(&$a,&$p){
   return ord($a[$p++]);
}
function getch(&$a,&$p){
   return $a[$p++];
}
function getint2(&$a,&$p){
   return ord($a[$p++])+(ord($a[$p++])<<8);
}
function getint2mac($a,&$p){
   return (ord($a[$p++])<<8)+ord($a[$p++]);
}
function int42str($a){
   return chr($a&255).chr(($a>>8)&255).chr(($a>>16)&255).chr(($a>>24)&255);
}
function int22str($a){
   return chr($a&255).chr(($a>>8)&255);
}
function getstr(&$a,&$p,$len){
   $s=substr($a,$p,$len); $p+=$len; return $s;
}

function putstr(&$f,&$p,&$s){
   for($i=0;$i<strlen($s);$i++) $f[$p++]=$s[$i];
}

function write_bmp($fn,$wh,$hh,$dt,$pal,$bpp,$sl,$whb){
   if($bpp==2){
      $dt=convbpp($dt); $whb<<=1; $bpp=4;
      $pal.=str_repeat("\x00",48);
   }
      $wb=(($wh*$bpp+31)&~31)>>3; $ls=(($wh*$bpp+7)&~7)>>3;
      $pl=($bpp<=8)?(4<<$bpp):0;
      $s="BM";
      $s.=int42str(0x36+$wb*$hh+$pl);
      $s.="\x00\x00\x00\x00";
      $s.=int42str(0x36+$pl);
      $s.="\x28\x00\x00\x00";
      $s.=int42str($wh);
      $s.=int42str($hh);
      $s.="\x01\x00";
      $s.=int22str($bpp);
      $s.="\x00\x00\x00\x00";
      $s.=int42str($wb*$hh);
      $s.="\xC4\x0E\x00\x00";
      $s.="\xC4\x0E\x00\x00";
      $s.="\x00\x00\x00\x00";
      $s.="\x00\x00\x00\x00";
      $s.=substr($pal,0,$pl);
      $pd=str_repeat("\x00",$wb-$ls);
      for($i=0;$i<$hh;$i++){
         if($sl&&$bpp>8){
            for($j=0;$j<($whb/ceil($bpp/8));$j++){
               for($p=ceil($bpp/8)-1;$p>=0;$p--){
                  $s.=substr($dt,$whb*($hh-$i-1)+$j+$p*$wh,1);
               }
            }
         }else{
            if($bpp>8){
               for($j=0;$j<$wh;$j++){
                  $s.=strrev(substr($dt,$whb*($hh-$i-1)+$j*ceil($bpp/8),ceil($bpp/8)));
               }
            }else{
               $s.=substr($dt,$whb*($hh-$i-1),$ls);
            }
         }
         $s.=$pd;
      }
      $fp_out=fopen($fn,"wb");
      fwrite($fp_out,$s);
      fclose($fp_out);
}

// decompression functions

function decmap32(&$f,&$p,$si){
   $out=str_repeat("\x00",$si); $o=0;
   $end=false;
   while($o<$si and !$end){
      $t=getint2($f,$p);
      if($t&0x2000){
         switch($t&0xE000){
            case 0x2000: $t&=0x1FFF; $ti=getint2($f,$p); putstr($out,$o,str_repeat(int22str($ti),$t)); break;
            case 0x6000: $t&=0x1FFF; $ti=getint2($f,$p); for($i=0;$i<$t;$i++) putstr($out,$o,int22str($ti++)); break;
            case 0xA000: $t&=0x1FFF; $ti=getint2($f,$p); for($i=0;$i<$t;$i++) putstr($out,$o,int22str($ti--)); break;
            default: die(sprintf("map %04X @ %04X",$t,$p));
         }
      }else{
         putstr($out,$o,int22str($t));
      }
   }
   return $out;
}

function decblk2(&$f,&$p,$si){
   $out=str_repeat("\x00",$si); $o=0;
   $end=false;
   while($o<$si and !$end){
      $t=getint1($f,$p);
      if($t&0x20){
         switch($t&0xE0){
            case 0x20: $p--; $t=getint2mac($f,$p); $t&=0x1FFF; $ti=getint2mac($f,$p); putstr($out,$o,str_repeat(int22str($ti),$t)); break;
            case 0x60: $p--; $t=getint2mac($f,$p); $t&=0x1FFF; $ti=getint2mac($f,$p); for($i=0;$i<$t;$i++) putstr($out,$o,int22str($ti++)); break;
            case 0xA0: $t&=0x1F; putstr($out,$o,substr($out,$o-$o%0x60+$t*2,2)); break;
            case 0xE0: $t&=0x1F; putstr($out,$o,substr($out,$o-$o%0x60+($t+0x20)*2,2)); break;
            default: die(sprintf("blk2 %04X @ %04X",$t,$p));
         }
      }else{
         $p--; putstr($out,$o,int22str(getint2mac($f,$p)));
      }
   }
   return $out;
}

function decblk(&$f,&$p,$si){
   $out=str_repeat("\x00",$si); $o=0;
   $end=false;
   while($o<$si and !$end){
      $t=getint1($f,$p);
      if($t&0x20){
         switch($t&0xE0){
            case 0x20: $t&=0x1F; $ti=getint2mac($f,$p); putstr($out,$o,str_repeat(int22str($ti),$t)); break;
            case 0x60: $t&=0x1F; $ti=getint2mac($f,$p); for($i=0;$i<$t;$i++) putstr($out,$o,int22str($ti++)); break;
            case 0xA0: $t&=0x1F; putstr($out,$o,substr($out,$o-$o%0x30+$t*2,2)); break;
            default: die(sprintf("blk %04X @ %04X",$t,$p));
         }
      }else{
         $p--; putstr($out,$o,int22str(getint2mac($f,$p)));
      }
   }
   return $out;
}

function dectile16(&$f,&$p,$nt){
   $ol=$nt*16;
   $out=str_repeat("\x00",$ol); $o=0;
   $end=false;
   while($o<$ol and !$end){
      $ar=array();
      $x=getint1($f,$p);
      switch($x){
         case 0x00:
            readallb($ar,$f,$p);
         break;
         case 0x01:
            fillallb($ar,$f,$p);
         break;
         case 0x02:
            fillall2b($ar,$f,$p);
         break;
         case 0x03:
            readallb2($ar,$f,$p);
         break;
         case 0x04:
            fillb2($ar,$f,$p);
            readr2($ar,$f,$p);
         break;
         case 0x05:
            fillb2($ar,$f,$p);
            fillb2($ar,$f,$p);
            readr2($ar,$f,$p);
         break;
         case 0x06:
            fill2b($ar,$f,$p);
            readr($ar,$f,$p);
         break;
         case 0x07:
            fill2b($ar,$f,$p);
            fill2b($ar,$f,$p);
            readr($ar,$f,$p);
         break;
         case 0x08:
            fill2b($ar,$f,$p);
            fill2b($ar,$f,$p);
            fill2b($ar,$f,$p);
            readr($ar,$f,$p);
         break;
         case 0x09:
            fill2b($ar,$f,$p);
            fill2b($ar,$f,$p);
            fill2b($ar,$f,$p);
            fill2b($ar,$f,$p);
         break;
         case 0x0A:
            readallbl($ar,$f,$p);
            fillbr($ar,$f,$p);
            fillbr($ar,$f,$p);
            readrr($ar,$f,$p);
         break;
         case 0x0B:
            fillbl($ar,$f,$p);
            readrl($ar,$f,$p);
            fillbr($ar,$f,$p);
            fillbr($ar,$f,$p);
            readrr($ar,$f,$p);
         break;
         case 0x0C:
            fillbl($ar,$f,$p);
            fillbl($ar,$f,$p);
            readrl($ar,$f,$p);
            readrr($ar,$f,$p);
         break;
         case 0x0D:
            fillbl($ar,$f,$p);
            fillbl($ar,$f,$p);
            readrl($ar,$f,$p);
            fillbr($ar,$f,$p);
            readrr($ar,$f,$p);
         break;
         case 0x0E:
            fillbl($ar,$f,$p);
            fillbl($ar,$f,$p);
            readrl($ar,$f,$p);
            fillbr($ar,$f,$p);
            fillbr($ar,$f,$p);
            readrr($ar,$f,$p);
         break;
         case 0x10:
            readb($ar,$f,$p);
            setr($ar,"\x00");
         break;
         case 0x11:
            readb($ar,$f,$p);
            setr($ar,"\x55");
         break;
         case 0x12:
            readb($ar,$f,$p);
            setr($ar,"\xAA");
         break;
         case 0x13:
            readb($ar,$f,$p);
            setr($ar,"\xFF");
         break;
         case 0x14:
            rept($ar,$f,$p,$out);
            read2b($ar,$f,$p);
         break;
         default: print "tile ".dechex($x)." @ ".dechex($p); $end=true;
      }
      ksort($ar);
      putstr($out,$o,implode("",$ar));
   }
   return $out;
}

function dectile32(&$f,&$p,$nt){
   $ol=$nt*32; $out=str_repeat("\x00",$ol); $o=0;
   $end=false;
   while($o<$ol and !$end){
      $ar=array();
      $x=getint1($f,$p);
      switch($x){
         case 0x00:
            readall_b($ar,$f,$p);
         break;
         case 0x01:
            fillall_b($ar,$f,$p);
         break;
         case 0x02:
            fillall4b($ar,$f,$p);
         break;
         case 0x03:
            fill4b($ar,$f,$p);
            read4r($ar,$f,$p);
         break;
         case 0x04:
            fill4b($ar,$f,$p);
            fill4b($ar,$f,$p);
            read4r($ar,$f,$p);
         break;
         case 0x05:
            fill4b($ar,$f,$p);
            fill4b($ar,$f,$p);
            fill4b($ar,$f,$p);
            read4r($ar,$f,$p);
         break;
         case 0x06:
            fill4b($ar,$f,$p);
            fill4b($ar,$f,$p);
            fill4b($ar,$f,$p);
            fill4b($ar,$f,$p);
            read4r($ar,$f,$p);
         break;
         case 0x07:
            read_vsp2($ar,$f,$p);
         break;
         case 0x08:
            read_vsp($ar,$f,$p);
         break;
         case 0x09:
            readb_($ar,$f,$p,0);
            readball_($ar,$f,$p,1);
            readball_($ar,$f,$p,16);
            readball_($ar,$f,$p,17);
         break;
         case 0x0A:
            readball_($ar,$f,$p,0);
            readb_($ar,$f,$p,1);
            readball_($ar,$f,$p,16);
            readball_($ar,$f,$p,17);
         break;
         case 0x0B:
            readb_($ar,$f,$p,0);
            readb_($ar,$f,$p,1);
            readball_($ar,$f,$p,16);
            readball_($ar,$f,$p,17);
         break;
         case 0x0C:
            readball_($ar,$f,$p,0);
            readball_($ar,$f,$p,1);
            readb_($ar,$f,$p,16);
            readball_($ar,$f,$p,17);
         break;
         case 0x0D:
            readb_($ar,$f,$p,0);
            readball_($ar,$f,$p,1);
            readb_($ar,$f,$p,16);
            readball_($ar,$f,$p,17);
         break;
         case 0x0E:
            readball_($ar,$f,$p,0);
            readb_($ar,$f,$p,1);
            readb_($ar,$f,$p,16);
            readball_($ar,$f,$p,17);
         break;
         case 0x0F:
            readb_($ar,$f,$p,0);
            readb_($ar,$f,$p,1);
            readb_($ar,$f,$p,16);
            readball_($ar,$f,$p,17);
         break;
         case 0x10:
            readball_($ar,$f,$p,0);
            readball_($ar,$f,$p,1);
            readball_($ar,$f,$p,16);
            readb_($ar,$f,$p,17);
         break;
         case 0x11:
            readb_($ar,$f,$p,0);
            readball_($ar,$f,$p,1);
            readball_($ar,$f,$p,16);
            readb_($ar,$f,$p,17);
         break;
         case 0x12:
            readball_($ar,$f,$p,0);
            readb_($ar,$f,$p,1);
            readball_($ar,$f,$p,16);
            readb_($ar,$f,$p,17);
         break;
         case 0x13:
            readb_($ar,$f,$p,0);
            readb_($ar,$f,$p,1);
            readball_($ar,$f,$p,16);
            readb_($ar,$f,$p,17);
         break;
         case 0x14:
            readball_($ar,$f,$p,0);
            readball_($ar,$f,$p,1);
            readb_($ar,$f,$p,16);
            readb_($ar,$f,$p,17);
         break;
         case 0x15:
            readb_($ar,$f,$p,0);
            readball_($ar,$f,$p,1);
            readb_($ar,$f,$p,16);
            readb_($ar,$f,$p,17);
         break;
         case 0x16:
            readball_($ar,$f,$p,0);
            readb_($ar,$f,$p,1);
            readb_($ar,$f,$p,16);
            readb_($ar,$f,$p,17);
         break;
         case 0x17:
            readb_($ar,$f,$p,0);
            readb_($ar,$f,$p,1);
            readb_($ar,$f,$p,16);
            readb_($ar,$f,$p,17);
         break;
         case 0x18:
            rept_($ar,$f,$p,&$out);
            read_2b($ar,$f,$p);
            set_r($ar,"\x00");
         break;
         case 0x19:
            rept_2($ar,$f,$p,&$out);
            read_2b($ar,$f,$p);
            set_r($ar,"\x00");
         break;
         default: print "tile32 ".dechex($x)." @ ".dechex($p); $end=true;
      }
      ksort($ar);
      putstr($out,$o,implode("",$ar));
   }
   return $out;
}

function readb2(&$ar,&$f,&$p){
   $m=getint1($f,$p);
   for($i=0;$i<8;$i++){
      if($m&1<<$i){
         $ar[$i*2]=$ar[$i*2+1]=getch($f,$p);
      }
   }
}
function readb(&$ar,&$f,&$p){
   $m=getint2($f,$p);
   for($i=0;$i<16;$i++){
      if(!($m&1<<$i)){
         $ar[$i]=getch($f,$p);
      }
   }
}
function readr(&$ar,&$f,&$p){
   for($i=0;$i<16;$i++){
      if(!isset($ar[$i])) $ar[$i]=getch($f,$p);
   }
}
function readr2(&$ar,&$f,&$p){
   for($i=0;$i<16;$i++){
      if(!isset($ar[$i])) $ar[$i]=$ar[$i+1]=getch($f,$p);
   }
}
function setr(&$ar,$x){
   for($i=0;$i<16;$i++){
      if(!isset($ar[$i])) $ar[$i]=$x;
   }
}
function fillb2(&$ar,&$f,&$p){
   $m=getint1($f,$p); $x=getch($f,$p);
   for($i=0;$i<8;$i++){
      if($m&1<<$i){
         $ar[$i*2]=$ar[$i*2+1]=$x;
      }
   }
}
function fill2b(&$ar,&$f,&$p){
   $m=getint1($f,$p); $x=getch($f,$p); $y=getch($f,$p);
   for($i=0;$i<8;$i++){
      if($m&1<<$i){
         $ar[$i*2]=$x; $ar[$i*2+1]=$y;
      }
   }
}
function readallb(&$ar,&$f,&$p){
   for($i=0;$i<16;$i++){
      $ar[$i]=getch($f,$p);
   }
}
function readallbl(&$ar,&$f,&$p){
   for($i=0;$i<8;$i++){
      $ar[$i*2]=getch($f,$p);
   }
}
function readallb2(&$ar,&$f,&$p){
   for($i=0;$i<8;$i++){
      $ar[$i*2]=$ar[$i*2+1]=getch($f,$p);
   }
}
function fillbl(&$ar,&$f,&$p){
   $m=getint1($f,$p); $x=getch($f,$p);
   for($i=0;$i<8;$i++){
      if($m&1<<$i){
         $ar[$i*2]=$x;
      }
   }
}
function fillbr(&$ar,&$f,&$p){
   $m=getint1($f,$p); $x=getch($f,$p);
   for($i=0;$i<8;$i++){
      if($m&1<<$i){
         $ar[$i*2+1]=$x;
      }
   }
}
function readrl(&$ar,&$f,&$p){
   for($i=0;$i<8;$i++){
      if(!isset($ar[$i*2])) $ar[$i*2]=getch($f,$p);
   }
}
function readrr(&$ar,&$f,&$p){
   for($i=0;$i<8;$i++){
      if(!isset($ar[$i*2+1])) $ar[$i*2+1]=getch($f,$p);
   }
}
function rept(&$ar,&$f,&$p,&$out){
   $x=getint2($f,$p);
   for($i=0;$i<16;$i++) $ar[$i]=$out[$x*16+$i]/*"&"*/;
}
function read2b(&$ar,&$f,&$p){
   $m=getint1($f,$p);
   for($i=0;$i<8;$i++){
      if(!($m&1<<$i)){
         $x=getch($f,$p); $y=getch($f,$p);
         $ar[$i*2]=$x; $ar[$i*2+1]=$y;
      }
   }
}
function fillall2b(&$ar,&$f,&$p){
   $x=getch($f,$p); $y=getch($f,$p);
   for($i=0;$i<8;$i++){
      $ar[$i*2]=$x; $ar[$i*2+1]=$y;
   }
}
function fillallb(&$ar,&$f,&$p){
   $x=getch($f,$p);
   for($i=0;$i<16;$i++){
      $ar[$i]=$x;
   }
}
function rept_(&$ar,&$f,&$p,&$out){
   $x=getint1($f,$p);
   for($i=0;$i<32;$i++) $ar[$i]=$out[$x*32+$i];
}
function read_2b(&$ar,&$f,&$p){
//   $x0=getch($f,$p);
   $m=getint1($f,$p);
   for($i=0;$i<8;$i++){
      if(!($m&1<<$i)){
         $x=getch($f,$p); $y=getch($f,$p);
         $ar[$i*2]=$x; $ar[$i*2+1]=$y;
         $x=getch($f,$p); $y=getch($f,$p);
         $ar[$i*2+16]=$x; $ar[$i*2+1+16]=$y;
      }//else $ar[$i*2]=$ar[$i*2+1]=$ar[$i*2+16]=$ar[$i*2+17]=$x0;
   }
}
function set_r(&$ar,$x){
   for($i=0;$i<32;$i++){
      if(!isset($ar[$i])) $ar[$i]=$x;
   }
}
function fillall_b(&$ar,&$f,&$p){
   $x=getch($f,$p);
   for($i=0;$i<32;$i++){
      $ar[$i]=$x;
   }
}

function readbl__(&$ar,&$f,&$p){
   $m=getint1($f,$p);
   for($i=0;$i<8;$i++){
      if(!($m&1<<$i)){
         $x=getch($f,$p);
         $ar[$i*2]=$x; 
      }
   }
}
function readb_(&$ar,&$f,&$p,$o){
   $x0=getch($f,$p);
   $m=getint1($f,$p);
   for($i=0;$i<8;$i++){
      if(!($m&1<<$i)){
         $x=getch($f,$p);
         $ar[$i*2+$o]=$x; 
      }else $ar[$i*2+$o]=$x0;
   }
}
function readball_(&$ar,&$f,&$p,$o){
   for($i=0;$i<8;$i++){
      $ar[$i*2+$o]=getch($f,$p);
   }
}

function fill4b(&$ar,&$f,&$p){
   $m=getint1($f,$p);
   $a=getch($f,$p);
   $b=getch($f,$p);
   $c=getch($f,$p);
   $d=getch($f,$p);
   for($i=0;$i<8;$i++){
      if($m&1<<$i){
         $ar[$i*2]=$a;
         $ar[$i*2+1]=$b;
         $ar[$i*2+16]=$c;
         $ar[$i*2+17]=$d;
      }
   }
}
function fillall4b(&$ar,&$f,&$p){
   $a=getch($f,$p);
   $b=getch($f,$p);
   $c=getch($f,$p);
   $d=getch($f,$p);
   for($i=0;$i<8;$i++){
      $ar[$i*2]=$a;
      $ar[$i*2+1]=$b;
      $ar[$i*2+16]=$c;
      $ar[$i*2+17]=$d;
   }
}
function fill4r(&$ar,&$f,&$p){
   $a=getch($f,$p);
   $b=getch($f,$p);
   $c=getch($f,$p);
   $d=getch($f,$p);
   for($i=0;$i<8;$i++){
      if(!isset($ar[$i*2])){
         $ar[$i*2]=$a;
         $ar[$i*2+1]=$b;
         $ar[$i*2+16]=$c;
         $ar[$i*2+17]=$d;
      }
   }
}
function read_vsp(&$ar,&$f,&$p){
   $m=getint1($f,$p);
   for($i=0;$i<8;$i++){
      if($m&1<<$i){
         $x=getint1($f,$p);
         $ar[$i*2]=chr(($x&3)*0x55);
         $ar[$i*2+1]=chr(($x>>2&3)*0x55);
         $ar[$i*2+16]=chr(($x>>4&3)*0x55);
         $ar[$i*2+17]=chr(($x>>6&3)*0x55);
      }else{
         $ar[$i*2]=getch($f,$p);
         $ar[$i*2+1]=getch($f,$p);
         $ar[$i*2+16]=getch($f,$p);
         $ar[$i*2+17]=getch($f,$p);
      }
   }
}

function readall_b(&$ar,&$f,&$p){
   for($i=0;$i<32;$i++) $ar[$i]=getch($f,$p);
}

function read4r(&$ar,&$f,&$p){
   for($i=0;$i<8;$i++){
      if(!isset($ar[$i*2])){
         $ar[$i*2]=getch($f,$p);
         $ar[$i*2+1]=getch($f,$p);
         $ar[$i*2+16]=getch($f,$p);
         $ar[$i*2+17]=getch($f,$p);
      }
   }
}

function read_vsp2(&$ar,&$f,&$p){
   $m=getint1($f,$p);
   for($i=0;$i<8;$i++){
      $ar[$i*2]=($m&1?"\xFF":"\x00");
      $ar[$i*2+1]=($m&2?"\xFF":"\x00");
      $ar[$i*2+16]=($m&4?"\xFF":"\x00");
      $ar[$i*2+17]=($m&8?"\xFF":"\x00");
   }
}
function rept_2(&$ar,&$f,&$p,&$out){
   $x=getint2($f,$p);
   for($i=0;$i<32;$i++) $ar[$i]=$out[$x*32+$i];
}

// export functions

function expfont(&$f,&$q,$id){
}

function expblock(&$f,&$p,$id,$ts,$bw,$bh,$nb,$nt){
   // blocks
   $n=getint2($f,$p);
   $blocks=array();
   while(count($blocks)<$nb){
      $x=getint2($f,$p);
      if($x>>15){
         $st=$x&0xFF; $ln=($x>>8)&0x7F; if(!$ln)$ln=0x80;
         for($i=0;$i<$ln;$i++) $blocks[]=$st++;
      }else{
         $st=$x&0xFF; $ln=($x>>8)&0x3F; if(!$ln)$ln=0x40;
         if($x>>14){
            for($i=0;$i<$ln;$i++) $blocks[]=$st;
         }else{
            $blocks[]=$st;
         }
      }
   }
   $ol=$n*2*$bw*$bh;
   if($bw==6) $out=decblk2($f,$p,$ol);
   elseif($bw==3) $out=decblk($f,$p,$ol);
   else die("Illegal bw ".$bw);
   $f_map="";
   $bs=$bw*$bh*2;
   for($i=0;$i<count($blocks);$i++){
      $f_map.=substr($out,$blocks[$i]*$bs,$bs);
   }
   // tiles
   $n=getint2($f,$p);
   $tiles=array();
   if($nt==0x100) $bt=8;
   elseif($nt==0x200) $bt=9;
   else die("Illegal nt ".$nt);
   $bn=15-$bt; $zt=1<<$bt; $mt=$zt-1; $zn=1<<$bn; $mn=$zn-1; $zn2=$zn>>1; $mn2=$zn2-1;
   while(count($tiles)<$nt){
      $x=getint2($f,$p); $st=$x&$mt;
      if($x>>15){
         $ln=($x>>$bt)&$mn;
         if(!$ln)$ln=$zn;
         for($i=0;$i<$ln;$i++) $tiles[]=$st++;
      }else{
         $ln=($x>>$bt)&$mn2;
         if(!$ln)$ln=$zn2;
         if($x>>14){
            for($i=0;$i<$ln;$i++) $tiles[]=$st;
         }else{
            $tiles[]=$st;
         }
      }
   }
   if($ts==1){ $out=dectile16($f,$p,$n); }
   elseif($ts==2){ $out=dectile32($f,$p,$n); }
   else die("Illegal ts ".$ts);
   $out2="";
   for($i=0;$i<count($tiles);$i++){
      $out2.=substr($out,($tiles[$i]<<4)*$ts,16*$ts);
   }
/*   $fp=fopen("ex_ti_".$id,"wb");
   fwrite($fp,$out2);
   fclose($fp);*/

   $ly=array(0x00,0x01,0x10,0x11,0x20,0x21,0x30,0x31);
   $q=0; $o=0; $f_til=str_repeat("\x00",$nt*64);
   while($q<strlen($out2)){
      for($y=0;$y<8;$y++){
         for($x=0;$x<8;$x++){
            $a=0;
            for($c=0;$c<2*$ts;$c++){
               if(ord($out2[$q+($y<<1)+$ly[$c]])&(128>>$x)) $a|=1<<$c;
            }
            $f_til[$o++]=chr($a);
         }
      }
      $q+=16*$ts;
   }
   unset($out2);
   // palette
   $pal0=""; for($i=0;$i<256;$i++) $pal0.=chr($i).chr($i).chr($i)."\x00";
   $pl=($id+3)&~3;
   switch($id&3){
      case 1: $pi=0; break;
      case 2: $pi=6; break;
      case 3: $pi=2; break;
   }
   if($id==74) $pl=$pi=-1;
   if($pi>=0){
      global $ad;
      $q=$ad[0][$pl]+0x200+($pi<<5);
      $pal="";
      for($c=0;$c<64;$c++){
         $co=getint2($f,&$q);
         $r=$co&0x1F; $g=($co>>5)&0x1F; $b=($co>>10)&0x1F;
         $pal.=int42str((($r<<16)|($g<<8)|$b)<<3);
      }
      $pal.=str_repeat("\x00",(256-64)*4);
      unset($ad);
   }else $pal=$pal0;
   // create bmp
   $fn_bmp=sprintf("exp0/%02d.bmp",$id);
   $tw=$th=8; //$r=2;
   if($ts==1){ $r=2; }
   elseif($ts==2){ $r=4; }
   else die("Illegal ts ".$ts);
   $wh=16; $hh=16;
   //$bw=3; $bh=8;

   $bm="";
   $bm.="BM";
   $bm.=int42str(0x436+$wh*$hh*$bw*$bh*$tw*$th);
   $bm.="\x00\x00\x00\x00";
   $bm.="\x36\x04\x00\x00";
   $bm.="\x28\x00\x00\x00";
   $bm.=int42str($wh*$bw*$tw);
   $bm.=int42str($hh*$bh*$th);
   $bm.="\x01\x00";
   $bm.="\x08\x00";
   $bm.="\x00\x00\x00\x00";
   $bm.=int42str($wh*$hh*$bw*$bh*$tw*$th);
   $bm.="\xC4\x0E\x00\x00";
   $bm.="\xC4\x0E\x00\x00";
   $bm.="\x00\x00\x00\x00";
   $bm.="\x00\x00\x00\x00";
   $bm.=$pal;
   $fl2=$fl1=0; $rr=0;
   $bm.=str_repeat("\x00",$wh*$hh*$bw*$bh*$tw*$th); $pb=0x436;
   for($s=$hh-1;$s>=0;$s--){
   for($s3=$bh-1;$s3>=0;$s3--){
      for($s2=$th-1;$s2>=0;$s2--){
         //$p_map=$s*$wh*2;
         for($o=0;$o<$wh;$o++){
            for($o3=0;$o3<$bw;$o3++){
               $p_map=((($s*$wh+$o)*$bh+$s3)*$bw+$o3)*2;
               $t=getint2($f_map,&$p_map);
               $ti=$t&0x3FF;if($r)$rr=(($t>>10)&7)<<$r;
               if($ti>=$nt) $ti=0; //$rr&=0x3F;
               $fl1=($t&0x4000)?($tw-1):0; $fl2=($t&0x8000)?($th-1):0; //$fl3=$t&0x4000;
               for($o2=0;$o2<$tw;$o2++){
                  $bm[$pb++]=$f_til[$ti*$tw*$th+($s2^$fl2)*$tw+($o2^$fl1)]|chr($rr);
               }
            }
         }
      }
   }
   }
   $fp_bmp=fopen($fn_bmp,"wb");
   fwrite($fp_bmp,$bm);
   fclose($fp_bmp);
//die("end for now");
}

function exppal(&$f,&$q,$id){
}

function exptiles(&$f,&$q,$id){
}

function expscr(&$f,&$q,$id){
   $si=0x700;
   if($id>=76 and $id<=78 or $id==84 or $id==91) $si=0x1C00;
   $f_map=decmap32($f,$q,$si);
   $nt=getint2($f,$q);
   $out=dectile32($f,$q,$nt);
   $ly=array(0x00,0x01,0x10,0x11,0x20,0x21,0x30,0x31);
   $p=0; $o=0; $f_til=str_repeat("\x00",strlen($out)<<1);
   while($p<strlen($out)){
      for($y=0;$y<8;$y++){
         for($x=0;$x<8;$x++){
            $a=0;
            for($c=0;$c<4;$c++){
               if(ord($out[$p+($y<<1)+$ly[$c]])&(128>>$x)) $a|=1<<$c;
            }
            $f_til[$o++]=chr($a);
         }
      }
      $p+=32;
   }
   unset($out);
   $pi=-1; $pl=69;
   if($id==71) $pi=1; // princess room
   if($id==72) $pi=1; // princess room arches
   if($id==75) $pi=6; // Masiya logo
   if($id==76) $pi=8; // stars
   if($id==77) $pi=18; // torture
   if($id==78) $pi=21; // garden
   if($id==79) $pi=8; // title
   if($id==80) $pi=8; // title things
   if($id==81) $pi=10; // pattern
   if($id==82) $pi=8; // game name
   if($id==83) $pi=12; // main menu bg
   if($id==84) $pi=12; // where Jafar walks
   if($id==85) $pi=16; // ending: prince at sultan
   if($id==86) $pi=16; // ending: prince and princess at window with people
   if($id==87) $pi=16; // ending: prince and princess at window with sundown
   if($id==88) $pi=17; // ending: sundown
   if($id==89) $pi=17; // ending: sundown 2
   if($id==90) $pi=6; // japanese characters
   if($id==91) $pi=26; // Konami logo
   $pal0=""; for($i=0;$i<256;$i++) $pal0.=chr($i).chr($i).chr($i)."\x00";
   if($pi>=0){
      global $ad;
      $p=$ad[0][$pl]+0x200+($pi<<5);
      $pal="";
      for($c=0;$c<64;$c++){
         $co=getint2($f,&$p);
         $r=$co&0x1F; $g=($co>>5)&0x1F; $b=($co>>10)&0x1F;
         $pal.=int42str((($r<<16)|($g<<8)|$b)<<3);
      }
      unset($ad);
   }else $pal=$pal0;
   // create BMP
   $fn_bmp=sprintf("exp0/%02d.bmp",$id);
   $tw=$th=8; $r=4;
   switch($si){
      case 0x700: $wh=32; $hh=28; break;
      case 0x1C00: $wh=64; $hh=56; break;
   }
   $bm="";
   $bm.="BM";
   $bm.=int42str(0x436+$wh*$hh*$tw*$th);
   $bm.="\x00\x00\x00\x00";
   $bm.="\x36\x04\x00\x00";
   $bm.="\x28\x00\x00\x00";
   $bm.=int42str($wh*$tw);
   $bm.=int42str($hh*$th);
   $bm.="\x01\x00";
   $bm.="\x08\x00";
   $bm.="\x00\x00\x00\x00";
   $bm.=int42str($wh*$hh*$tw*$th);
   $bm.="\xC4\x0E\x00\x00";
   $bm.="\xC4\x0E\x00\x00";
   $bm.="\x00\x00\x00\x00";
   $bm.="\x00\x00\x00\x00";
   $bm.=$pal;
   $fl2=$fl1=0; $rr=0;
   $bm.=str_repeat("\x00",$wh*$hh*$tw*$th); $pb=0x436;
   for($s=$hh-1;$s>=0;$s--){
      for($s2=$th-1;$s2>=0;$s2--){
         $p_map=$s*$wh*2;
         for($o=0;$o<$wh;$o++){
            $t=getint2($f_map,&$p_map);//$map[$s][$o];
            $ti=$t&0x3FF;if($r)$rr=(($t>>10)&7)<<$r;
            if($ti>=$nt) $ti=0; $rr&=0x3F;
            $fl1=($t&0x4000)?($tw-1):0; $fl2=($t&0x8000)?($th-1):0; //$fl3=$t&0x4000;
            for($o2=0;$o2<$tw;$o2++){
               $bm[$pb++]=$f_til[$ti*$tw*$th+($s2^$fl2)*$tw+($o2^$fl1)]|chr($rr);
            }
         }
      }
   }
   $fp_bmp=fopen($fn_bmp,"wb");
   fwrite($fp_bmp,$bm);
   fclose($fp_bmp);
}

function expspr(&$f,&$q,$id){
   $pl=68;
   $pi=-1;
   // select palette
   if($id>=0 and $id<=63 or $id>=65 and $id<=161 or $id>=183 and $id<=196 or
      $id>=276 and $id<=307 or $id>=404 and $id<=448 or $id>=673 and $id<=696 or
      $id>=700 and $id<=751 or $id>=770 and $id<=803 or $id>=1201 and $id<=1204 or
      $id>=1153 and $id<=1156 or $id>=364 and $id<=365) $pi=0; // prince
   if($id>=212 and $id<=275) $pi=9; // fat
   if($id>=244 and $id<=275 or $id>=1157 and $id<=1200 or $id>=1221 and $id<=1231 or
      $id>=1246 and $id<=1248) $pi=11; // guard
   if($id>=308 and $id<=339) $pi=4; // skel
   if($id>=340 and $id<=363 or $id>=366 and $id<=371) $pi=17; // l
   if($id>=372 and $id<=403 or $id>=522 and $id<=551 or $id>=625 and $id<=632 or
      $id>=813 and $id<=935 or $id>=1139 and $id<=1144) $pi=20; // jaffar
   if($id>=449 and $id<=521 or $id>=552 and $id<=624 or $id>=633 and $id<=672 or
      $id>=1205 and $id<=1220 or $id>=1232 and $id<=1235) $pi=3; // princess
   if($id>=936 and $id<=988) $pi=8; // girl
   if($id>=989 and $id<=1064) $pi=19; // x
   if($id>=1077 and $id<=1086) $pi=21; // mouse
   if($id>=752 and $id<=769) $pi=23; // prince fire
   if($id>=1088 and $id<=1096) $pi=24; // potion
   if($id>=1097 and $id<=1108){ $pl=69; $pi=5; } // hourglass
   if($id>=1145 and $id<=1152) $pi=25; // elephant
   if($id==64 or $id==1087) $pi=23; // fire and hardhit
   if($id>=162 and $id<=182 or $id>=199 and $id<=211 or $id>=804 and $id<=812 or
      $id>=697 and $id<=699) $pi=22; // sword
   if($id>=1065 and $id<=1076) $pi=-1; // skull
   if($id>=1109 and $id<=1138){ $pl=69; $pi=6; } // pegasus
   // find palette
   $pal0="";
   for($i=0;$i<16;$i++) $pal0.=str_repeat(chr($i*17),3)."\x00";
   if($pi>=0){
      global $ad;
      $p=$ad[0][$pl]+0x200+($pi<<5);
      $pal="";
      for($c=0;$c<16;$c++){
         $co=getint2($f,&$p);
         $r=$co&0x1F; $g=($co>>5)&0x1F; $b=($co>>10)&0x1F;
         $pal.=int42str((($r<<16)|($g<<8)|$b)<<3);
      }
      unset($ad);
   }else $pal=$pal0;
   $fn=sprintf("%04d",$id);
   $p=$q;
   $rw=getint1($f,$p)+1; $rh=getint1($f,$p)+1;
   $x=getint1($f,$p); $hh=$x>>4; $wh=$x&0xF;
   // decompress
   $ly=array(0x00,0x01,0x10,0x11,0x20,0x21,0x30,0x31);
   $out="";
   for($i=0;$i<$wh*$hh*2;$i++){
      $mm=getint1($f,$p);
      $ar=str_repeat("\x00",64);
      for($l=0;$l<8;$l++){
         if(!($mm&1<<$l)) continue;
         $o=$ly[$l];
         $m=getint1($f,$p);
         if($m==255){$m=getint1($f,$p);$fill=true;}else $fill=false;
         if($fill){
            $ch=getch($f,$p);
            for($b=0;$b<8;$b++){
               if(!($m&1<<$b)) $ar[$b*2+$o]=$ch;
            }
         }else{
            for($b=0;$b<8;$b++){
               if(!($m&1<<$b)) $ar[$b*2+$o]=getch($f,$p);
            }
         }
      }
      $out.=$ar;
   }
   // convert from planar to interleaved
   $dt=""; $o=0;
   for($i=0;$i<$hh;$i++){
      $li=array(); for($l=0;$l<16;$l++) $li[$l]="";
      for($j=0;$j<$wh;$j++){
         for($i2=0;$i2<2;$i2++){
            for($j2=0;$j2<2;$j2++){
               for($y=0;$y<8;$y++){
                  for($x=0;$x<8;$x++){
                     $a=0;
                     for($c=0;$c<4;$c++){
                        if(ord($out[$o+($y<<1)+$ly[$c]])&(128>>$x)) $a|=1<<$c;
                     }
                     $li[($i2<<3)+$y].=chr($a);
                  }
               }
               $o+=32;
            }
         }
      }
      for($l=0;$l<16;$l++) $dt.=$li[$l];
   }
   $pal.=str_repeat("\x00",(256-16)*4);
   write_bmp(sprintf("exp1\\%04d.bmp",$id),$rw,$rh,$dt,$pal,8,false,$wh<<4);
}

function expnspr(&$f,&$q,$id){
   $pl=68;
   $pi=-1;
   $mono=false;
   if($id>=1249 and $id<=1254 or $id==1297){ $pl=4; $pi=6; } // blue dungeon
   if($id>=1255 and $id<=1260 or $id==1298){ $pl=8; $pi=6; } // pink palace
   if($id>=1261 and $id<=1266 or $id==1299){ $pl=12; $pi=6; } // grey palace
   if($id>=1267 and $id<=1272 or $id==1300){ $pl=16; $pi=6; } // red dungeon
   if($id>=1273 and $id<=1278 or $id==1301){ $pl=20; $pi=6; } // green palace
   if($id>=1279 and $id<=1284 or $id==1302){ $pl=24; $pi=6; } // brown dungeon
   if($id>=1285 and $id<=1290 or $id==1303){ $pl=28; $pi=6; } // red palace
   if($id>=1291 and $id<=1296){ $pl=20; $pi=6; } // green palace bluish
   if($id==1304){ $pl=32; $pi=6; } // level 20
   if($id>=1305 and $id<=1314){ $pl=4; $pi=6; } // chomper
   if($id>=1315 and $id<=1333){ $pl=4; $pi=6; } // guillotine
   if($id>=1334 and $id<=1339){ $pl=24; $pi=6; } // log
   if($id>=1340 and $id<=1345){ $pl=4; $pi=6; } // spike
   if($id==1346){ $pl=4; $pi=6; } // ?
   if($id>=1347 and $id<=1358){ $pl=24; $pi=6; } // stars
   if($id>=1359 and $id<=1369){ $pl=4; $pi=6; } // door
   if($id==1370){ $pl=8; $pi=6; } // mirror
   if($id==1371){ $pl=4; $pi=6; } // skeleton
   if($id==1372){ $pl=4; $pi=6; } // unknown trap
   if($id>=1373 and $id<=1379){ $pl=4; $pi=6; } // crusher
   if($id>=1380 and $id<=1383){ $pl=4; $pi=6; } // magical floor
   if($id>=1384 and $id<=1387){ $pl=16; $pi=6; } // fire
   if($id>=1388 and $id<=1394){ $pl=4; $pi=6; } // conveyor belt
   if($id>=1395) $mono=true;
   
   // find palette
   $pal0="";
   for($i=0;$i<16;$i++) $pal0.=str_repeat(chr($i*17),3)."\x00";
   if($pi>=0){
      global $ad;
      $p=$ad[0][$pl]+0x200+($pi<<5);
      $pal="";
      for($c=0;$c<16;$c++){
         $co=getint2($f,&$p);
         $r=$co&0x1F; $g=($co>>5)&0x1F; $b=($co>>10)&0x1F;
         $pal.=int42str((($r<<16)|($g<<8)|$b)<<3);
      }
      unset($ad);
   }else $pal=$pal0;
   
   $p=$q;
   $p0=$p;
   // decompress
   for($i=0;$i<6;$i++) $ad[$i]=getint2($f,$p);
   $wh=6;
   $hh=0x40;
   $out2="";
   $x=0;
   for($i=0;$i<$wh;$i++){
      $out="";
      if($ad[$i]) $p=$p0+$ad[$i]; else $out=str_repeat($mono?"\x00":"\xFF\x00\x00\x00\x00",$hh);
      while(strlen($out)<($mono?$hh:$hh*5)){
         $t=getint1($f,$p);
         if($t&0x80){
            $out.=str_repeat($mono?"\x00":"\xFF\x00\x00\x00\x00",$t&0x7F);
         }else{
            $out.=getstr($f,$p,$mono?$t:5*$t);
         }
      }
      $out2.=$out;
   }
   $out=$out2; unset($out2);
   // convert from planar to interleaved
   $p=0;
   $v=array();
   $dt=str_repeat("\x00",$mono?$wh*$hh*8:$wh*$hh);
   for($x=0;$x<$wh;$x++){
      for($y=0;$y<$hh;$y++){
         if($mono){
            $dt[$y*$wh+$x]=chr(getint1($out,$p));
         }else{
            $p++;
            for($j=0;$j<4;$j++){
               $v[$j]=getint1($out,$p);
            }
            for($x2=0;$x2<8;$x2++){
               $a=0;
               for($c=0;$c<4;$c++){
                  if($v[$c]&(128>>$x2)) $a|=1<<$c;
               }
               $dt[$y*($wh<<3)+($x<<3)+$x2]=chr($a);
            }
         }
      }
   }
   $pal.=str_repeat("\x00",(256-16)*4);
   write_bmp(sprintf("exp1\\%04d.bmp",$id),$wh<<3,$hh,$dt,$mono?
   "\x00\x00\x00\x00\xFF\xFF\xFF\x00":$pal,$mono?1:8,false,$mono?$wh:$wh<<3);
}

if($argc<=1) die("Name of ROM file must be given as command line parameter!");
$fn=$argv[1];
if(!file_exists($fn)) die(sprintf('ROM file "%s" does not exist!',$fn));
if(filesize($fn)!=0x100200) die(sprintf('ROM file "%s" has wrong size!',$fn));
$f=file_get_contents($fn);
$ar=array(0x20000,0x78000,0xE8000);
$ad=array();
for($ix=0;$ix<count($ar);$ix++){
   $ad[$ix]=array();
   $p=$ar[$ix]+0x200;
   $mi=strlen($f)-0x200; $id=0;
   while($p<$mi+0x200){
      $of=getint2($f,$p); $sg=getint1($f,$p); $x=($sg<<15)+($of&0x7FFF); $ad[$ix][$id]=$x;
      if($x<$mi) $mi=$x;
      $id++;
   }
}
for($ix=0;$ix<count($ar);$ix++){
   mkdir("exp".$ix);
   for($id=0;$id<count($ad[$ix]);$id++){
      $q=$ad[$ix][$id]+0x200;
      switch($ix){
         case 0:
            if($id==0){
               expfont($f,$q,$id);
            }elseif($id>=1 and $id<=40){
               switch($id&3){
                  case 1: expblock($f,$q,$id,1,3,8,0x100,0x200); break;
                  case 2: expblock($f,$q,$id,2,6,8,0x100,0x100); break;
                  case 3: expblock($f,$q,$id,2,3,8,0x100,0x100); break;
                  case 0: exppal($f,$q,$id); break;
               }
            }elseif($id==68 or $id==69){
               exppal($f,$q,$id);
            }elseif($id==70 or $id==73){
               exptiles($f,$q,$id);
            }elseif($id==71 or $id==72 or $id>=75 and $id<=91){
               expscr($f,$q,$id);
            }elseif($id==74){
               expblock($f,$q,$id,1,3,8,0x100,0x200);
            }
         break;
         case 1:
            if($id>=0 and $id<=1248){
               expspr($f,$q,$id);
            }elseif($id>=1249 and $id<=1484){
               expnspr($f,$q,$id);
            }
         break;
         case 2:
         break;
      }
   }
}

?>